

/**
	This is JDataset online demo.
	visit http://www.codeboogie.com/document.php?doc=api to see online API document.
	----------------------------------------------------------------------------------
	JDataset description:
	Copyright CodeBoogie LTD. http://www.codeboogie.com
	You allowed to use this component or parts of it for trail on 30 days.
	To use it on other terms or get Professional edition of the component please contact us at 	sales@codeboogie.com
 */


var ds,  //JDataset object. Holding the data get from server.
	tableDS;  // JDataset object. Holding the result table showing data.

function onGetDataClick() {
	ds = new JDataset("customer");
	var div = document.getElementById("customer-list");  
	ds.loadFromJSON({url: "data/customer.json?random="+ parseInt(1000*Math.random()),
					 onSend: function() {
						 div.innerHTML = "on sending data";
					 },
					 onProcess: function() {
						 div.innerHTML = "<img src='../images/ajax-loader.gif' />";
					 },
					 onError: function(code, msg) {						 
						 if(code == 0) {
							 div.innerHTML = "<a href='http://codeboogie.com/demo/customer-mgr.html'>Local file vist error. this error should be raised in local file mode, you should put all files to web server or visti the online version at codeboogie.com. </a>";
						 } else {
							 div.innerHTML = "error code " + code + " : " + msg;
						 }
					 },
					 onSuccess: function(xhr) {			 
						 ds.showTable("customer-list");
						 tableDS = ds;
						 
						 //initialize fieldName HTMLSelectElement
						 var fieldName = document.getElementById("fieldName");
						 if(fieldName) {
							 fieldName.options.length = 0;
							 var op = new Option("please select", "", true);
							 fieldName.options[fieldName.length] = op;
							 ds.foreachColumn(function(col, value){
								 	op = new Option(col, col);
									fieldName.options[fieldName.length] = op;
								 });
						 }
						 
						 var fieldValue = document.getElementById("fieldValue");					 
					}
				});	
}

function onFieldNameChange() {
	if(!ds) return;
	var fieldName = document.getElementById("fieldName"),  
		fieldValue = document.getElementById("fieldValue");
	// initialize fieldValue HTMLSelectElement
	fieldValue.options.length = 0;
	var values = ds.vals(fieldName.value, true);
	values.sort();
	for(var i = 0 ; i < values.length; i ++){
		var op = new Option(values[i], values[i]);		
		fieldValue.options[fieldValue.length] = op;
	}
}

function onFilterDataClick() {
	if(!ds) {
		alert("Must load data before filter");
		return;
	}
	var filter = {}, resultDS = {},
	fieldName = document.getElementById("fieldName"), 
	fieldValue = document.getElementById("fieldValue"); 
	
	if(fieldName.value == "" || fieldValue.value == "") {
		alert("Must set fieldName and fieldValue!");
		return;
	}
	
	filter[fieldName.value] = fieldValue.value;
	resultDS = ds.filter(filter);
	
	resultDS.showTable("customer-list");
	tableDS = resultDS;
}

function onClearFilterClick() {
	if(!ds) {
		alert("please load data first");
		return;
	}
	
	ds.showTable("customer-list");
	tableDS = ds;
}

function onPostTableClick() {
	if(!tableDS){
		alert("Must get data");
		return;
	};
	var feeback= document.getElementById("postFeeback");
	tableDS.post({
		url: "customer-result.php",
		onSend: function() {
			feeback.innerHTML = "<h1>on sending request</h1>";
		},
		onProcess: function() {
			feeback.innerHTML = "<h1>on processing</h1>";
		},
		onError: function(code, msg) {
			feeback.innerHTML="<h1>error code " + code + " : " + msg+"</h1>";
		},
		onSuccess: function(xhr) {
			feeback.innerHTML = xhr.responseText;
		}
	});
}